<?php
declare(strict_types = 1);
namespace InternetGalerie\Igshop2\Controller;

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use TYPO3\CMS\Backend\Routing\UriBuilder;
use TYPO3\CMS\Backend\Template\Components\ButtonBar;
use TYPO3\CMS\Backend\Template\ModuleTemplate;
use TYPO3\CMS\Backend\Tree\View\ElementBrowserFolderTreeView;
use TYPO3\CMS\Core\Authentication\BackendUserAuthentication;
use TYPO3\CMS\Core\Http\HtmlResponse;
use TYPO3\CMS\Core\Http\JsonResponse;
use TYPO3\CMS\Core\Imaging\Icon;
use TYPO3\CMS\Core\Imaging\IconFactory;
use TYPO3\CMS\Core\Localization\LanguageService;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Recordlist\Tree\View\DummyLinkParameterProvider;

use Internetgalerie\IgBackendHelpers\Controller\AbstractNavigationFrameController;
use Internetgalerie\IgBackendHelpers\View\PageTreeView;


use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Database\Connection;
use TYPO3\CMS\Core\Database\Query\Restriction\DeletedRestriction;
use TYPO3\CMS\Backend\Utility\BackendUtility;

/**
 * Main script class for rendering of the folder tree
 * @internal This class is a specific Backend controller implementation and is not considered part of the Public TYPO3 API.
 */
class BackendNavigationFrameController extends AbstractNavigationFrameController
{
    /**
     * Additional clause for selecting pages e.g. ' AND doktype=254 ' for all system folders
     *
     * @var string
     */
    // protected $additionalSqlWhere = 'AND doktype=254';


    /**
     * Table name for categories
     *
     * @var string
     */
    protected $tableName = 'tx_igshop2_domain_model_category';
    
}
