<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\CategoryRepository;
use InternetGalerie\Igshop2\Domain\Repository\ProductRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\ObjectStorage;

/**
 * Category
 */
class Category extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * hidden
	 *
	 * @var bool
	 */
	protected $hidden = false;

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

	/**
	 * description
	 *
	 * @var string
	 */
	protected $description = '';

	/**
	 * description
	 *
	 * @var string
	 */
	protected $teaser = '';

    /**
     * externalId
     *
     * @var string
     */
    protected $externalId = '';

	/**
	 * sorting
	 *
	 * @var integer
	 */
	protected $sorting = 0;


	/**
	 * active
	 *
	 * @var boolean
	 */
	protected $active = FALSE;

	/**
	 * withoutPorto
	 *
	 * @var boolean
	 */
	protected $withoutPorto = FALSE;

	/**
	 * hideInNavigation
	 *
	 * @var boolean
	 */
	protected $hideInNavigation = FALSE;

	/**
	 * excludeSlug
	 *
	 * @var boolean
	 */
	protected $excludeSlug = FALSE;

	/**
	 * Parent ID
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Category
	 */
	protected $parent = NULL;

    /**
     * _languageUid
     * @var ?int
     */
    protected ?int $_languageUid;

    /**
     * _localizedUid
     * @var ?int
     */
    protected ?int $_localizedUid;

    /**
     * Parent ID
     *
     * @var \InternetGalerie\Igshop2\Domain\Model\CategoryView
     */
    protected $view = null;

	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
	 */
	protected $image = NULL;

    /**
     * detail page uid
     *
     * @var int
     */
    protected $listPageUid = 0;

    /**
     * detail page uid
     *
     * @var int
     */
    protected $detailPageUid = 0;


	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Property>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected ?ObjectStorage $properties = null;

	/**
	 * products
	 *
	 * var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product>
	 * TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
    //protected $products = null;

    //protected $subcategories = null;

    public function __construct() {
        //$this->products = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->subcategories=null;
		$this->image = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->properties = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }
	/**
	 * Returns the hidden
	 *
	 * @return bool $hidden
	 */
	public function getHidden() {
	  return $this->hidden;
	}
	/**
	 * Sets the hidden
	 *
	 * @param bool $hidden
	 * @return void
	 */
	public function setHidden($hidden) {
	  $this->hidden = $sorting;
	}

	/**
	 * Returns the sorting
	 *
	 * @return integer $sorting
	 */
	public function getSorting() {
	  return $this->sorting;
	}
	/**
	 * Sets the sorting
	 *
	 * @param integer $sorting
	 * @return void
	 */
	public function setSorting($sorting) {
	  $this->sorting = $sorting;
	}


	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the description
	 *
	 * @return string $description
	 */
	public function getDescription() {
		return $this->description;
	}

	/**
	 * Sets the description
	 *
	 * @param string $description
	 * @return void
	 */
	public function setDescription($description) {
		$this->description = $description;
	}

	/**
	 * Returns the teaser
	 *
	 * @return string $teaser
	 */
	public function getTeaser() {
		return $this->teaser;
	}

	/**
	 * Sets the teaser
	 *
	 * @param string $teaser
	 * @return void
	 */
	public function setTeaser($teaser) {
		$this->teaser = $teaser;
	}

    /**
     * Returns the externalId
     *
     * @return string $externalId
     */
    public function getExternalId(){
        return $this->externalId;
    }

    /**
     * Sets the externalId
     *
     * @param string $externalId
     * @return void
     */
    public function setExternalId($externalId){
        $this->externalId = $externalId;
    }

	/**
	 * Returns the active
	 *
	 * @return boolean $active
	 */
	public function getActive() {
		return $this->active;
	}

	/**
	 * Sets the active
	 *
	 * @param boolean $active
	 * @return void
	 */
	public function setActive($active) {
		$this->active = $active;
	}

	/**
	 * Returns the boolean state of active
	 *
	 * @return boolean
	 */
	public function isActive() {
		return $this->active;
	}

	/**
	 * Returns the withoutPorto
	 *
	 * @return boolean $withoutPorto
	 */
	public function getWithoutPorto() {
		return $this->withoutPorto;
	}

	/**
	 * Sets the withoutPorto
	 *
	 * @param boolean $withoutPorto
	 * @return void
	 */
	public function setWithoutPorto($withoutPorto) {
		$this->withoutPorto = $withoutPorto;
	}

	/**
	 * Returns the boolean state of withoutPorto
	 *
	 * @return boolean
	 */
	public function isWithoutPorto() {
		return $this->withoutPorto;
	}

	/**
	 * Returns the hideInNavigation
	 *
	 * @return boolean $hideInNavigation
	 */
	public function getHideInNavigation() {
		return $this->withoutPorto;
	}

	/**
	 * Sets the hideInNavigation
	 *
	 * @param boolean $hideInNavigation
	 * @return void
	 */
	public function setHideInNavigation($hideInNavigation) {
		$this->hideInNavigation = $hideInNavigation;
	}

	/**
	 * Returns the boolean state of hideInNavigation
	 *
	 * @return boolean
	 */
	public function isHideInNavigation() {
		return $this->hideInNavigation;
	}

	/**
	 * Returns the excludeSlug
	 *
	 * @return boolean $excludeSlug
	 */
	public function getExcludeSlug() {
		return $this->excludeSlug;
	}

	/**
	 * Sets the excludeSlug
	 *
	 * @param boolean $excludeSlug
	 * @return void
	 */
	public function setExcludeSlug($excludeSlug) {
		$this->excludeSlug = $excludeSlug;
	}

	/**
	 * Returns the boolean state of excludeSlug
	 *
	 * @return boolean
	 */
	public function isExcludeSlug() {
		return $this->excludeSlug;
	}

	/**
	 * Returns the parent
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Category $parent
	 */
	public function getParent() {
		return $this->parent;
	}
	public function getRealParent() {
        if ($this->parent instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->parent->_loadRealInstance();
        }
		return $this->parent;
	}

    public function getTopCategory() {
        return $this->parent ? $this->parent->getTopCategory() : $this;
    }

	/**
	 * Sets the parent
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Category $parent
	 * @return void
	 */
	public function setParent(\InternetGalerie\Igshop2\Domain\Model\Category $parent) {
		$this->parent = $parent;
	}

    /**
     * @param int $_languageUid
     * @return void
     */
    public function set_languageUid($_languageUid) {
      $this->_languageUid = $_languageUid;
    }

    /**
     * @return int
     */
    public function get_languageUid() {
      return $this->_languageUid;
    }
    /**
     * @param int $_localizedUid
     * @return void
     */
    public function set_localizedUid($_localizedUid) {
      $this->_localizedUid = $_localizedUid;
    }

    /**
     * @return int
     */
    public function get_localizedUid() {
      return $this->_localizedUid;
    }


    public function getSubcategories() {
        if(!$this->subcategories) {
			$categoryRepository = GeneralUtility::makeInstance(CategoryRepository::class);
            $this->subcategories = $categoryRepository->findByParent($this);
        }
        return $this->subcategories;
    }

    public function getFirstLetter()
    {
        return $this->getName()[0];
    }

    /**
     * Returns the view
     *
     * @return \InternetGalerie\Igshop2\Domain\Model\CategoryView $view
     */
    public function getView()
    {
        return $this->view;
    }

    /**
     * Sets the view
     *
     * @param \InternetGalerie\Igshop2\Domain\Model\CategoryView $view
     * @return void
     */
    public function setView(\InternetGalerie\Igshop2\Domain\Model\CategoryView $view)
    {
        $this->view = $view;
    }

	/**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 * @return void
	 */
	public function addImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image) {
		$this->image->attach($image);
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove The FileReference to be removed
	 * @return void
	 */
	public function removeImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove) {
		$this->image->detach($imageToRemove);
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getImage() {
		return $this->image;
	}
        /**
         * Returns the imageLocalized
         *
         * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
         */
        public function getImageLocalized() {
	  //return $this->getImage();
          return $this->getLocalized( 'image' );
        }

	/**
	 * Returns the mainimage
	 *
	 * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 */
	public function getMainImageLocalized() {
	  $imgs = $this->getImageLocalized();
	  return count($imgs) >0 ? $imgs[0] : null;
	}


	/**
	 * Sets the image
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 * @return void
	 */
	public function setImage(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $image) {
		$this->image = $image;
	}

    /**
     * Get the value of detail page uid
     *
     * @return int
     */
    public function getDetailPageUid()
    {
        return $this->detailPageUid;
    }

    /**
     * Set the value of detail page uid
     *
     * @param int $detailPageUid
     *
     * @return self
     */
    public function setDetailPageUid($detailPageUid)
    {
        $this->detailPageUid = $detailPageUid;

        return $this;
    }


    /**
     * Get the value of detail page uid
     *
     * @return int
     */
    public function getListPageUid()
    {
        return $this->listPageUid;
    }

    /**
     * Set the value of detail page uid
     *
     * @param int $listPageUid
     *
     * @return self
     */
    public function setListPageUid($listPageUid)
    {
        $this->listPageUid = $listPageUid;

        return $this;
    }

	/**
	 * Adds a Product
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Product $product
	 * @return void
	 */
    /*
	public function addProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product) {
		$this->products->attach($product);
	}
    */
	/**
	 * Removes a Product
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Product $product The FileReference to be removed
	 * @return void
	 */
    /*
	public function removeProduct(\InternetGalerie\Igshop2\Domain\Model\Product $product) {
		$this->products->detach($product);
	}
    */
	/**
	 * Returns the products
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $products
	 */
    /*
      public function getProducts() {
		return $this->products;
	}
    */
    public function getProducts() {
        if($this->products===null) {
            $this->productRepository= GeneralUtility::makeInstance(ProductRepository::class);
            $this->products = $this->productRepository->findByCategories([$this]);
        }
        return $this->products;
    }
    /**/
	public function getProductsCount() {
        if( $this->productsCount===null) {
            $this->productsCount=count($this->getProducts());
        }
		return $this->productsCount;
	}
    public function setProductsCount($productsCount) {
        $this->productsCount=$productsCount;
    }
    public function getProductLink() {
        if($this->productLink === null && $this->getProducts()->count() == 1) {
            $this->productLink = $this->getProducts()->offsetGet(0)->getUid();
        }
        return $this->productLink;
    }
    public function setProductLink( $productLink) {
        $this->productLink = $productLink;
    }
	/**
	 * Sets the products
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Product> $products
	 * @return void
	 */
	public function setProducts(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $products) {
		$this->products = $products;
	}

	public function setProperties(ObjectStorage $properties): void
	{
		$this->properties = $properties;
	}

	public function getProperties(): ?ObjectStorage
	{
		return $this->properties;
	}

	public function addProperty(Property $property)
	{
		$this->properties->attach($property);
	}

	public function hasProperty(Property $property)
	{
		return $this->properties->contains($property);
	}

	public function removeProperty(Property $property)
	{
		$this->properties->detach($property);
	}

}
