<?php
namespace InternetGalerie\Igshop2\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2015
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Country
 */
class Country extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

	/**
	 * short
	 *
	 * @var string
	 */
	protected $short = '';

	/**
	 * currency
	 *
	 * @var \InternetGalerie\Igshop2\Domain\Model\Currency
	 */
	protected $currency = NULL;

	/**
	 * dataTrigger
	 *
	 * @var string
	 */
	protected $dataTrigger = '';

	/**
	 * _languageUid
	 * @var ?int
	 */
	protected ?int $_languageUid;


	/**
	 * _localizedUid
	 * @var ?int
	 */
	protected ?int $_localizedUid;

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the short
	 *
	 * @return string $short
	 */
	public function getShort() {
		return $this->short;
	}

	/**
	 * Sets the short
	 *
	 * @param string $short
	 * @return void
	 */
	public function setShort($short) {
		$this->short = $short;
	}

	/**
	 * Returns the currency
	 *
	 * @return \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 */
	public function getCurrency() {
		return $this->currency;
	}

	/**
	 * Sets the currency
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @return void
	 */
	public function setCurrency(\InternetGalerie\Igshop2\Domain\Model\Currency $currency) {
		$this->currency = $currency;
	}

	/**
	 * Returns the dataTrigger
	 *
	 * @return string $dataTrigger
	 */
	public function getData() {
		return $this->dataTrigger ? [ 'trigger' => $this->dataTrigger] : [];
	}
	/**
	 * Returns the dataTrigger
	 *
	 * @return string $dataTrigger
	 */
	public function getDataTrigger() {
		return $this->dataTrigger;
	}

	/**
	 * Sets the dataTrigger
	 *
	 * @param string $dataTrigger
	 * @return void
	 */
	public function setDataTrigger($dataTrigger) {
		$this->dataTrigger = $dataTrigger;
	}

	/**
	 * @param int $_languageUid
	 * @return void
	 */
	public function set_languageUid($_languageUid) {
	  $this->_languageUid = $_languageUid;
	}

	/**
	 * @return int
	 */
	public function get_languageUid() {
	  return $this->_languageUid;
	}

	/**
	 * @param int $_localizedUid
	 * @return void
	 */
	public function set_localizedUid($_localizedUid) {
	  $this->_localizedUid = $_localizedUid;
	}

	/**
	 * @return int
	 */
	public function get_localizedUid() {
	  return $this->_localizedUid;
	}
}
