<?php
namespace InternetGalerie\Igshop2\Domain\Model;

use InternetGalerie\Igshop2\Domain\Repository\CurrencyRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * OptionWithPrice
 */
class OptionWithPrice extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * name
	 *
	 * @var string
	 */
	protected $name = '';

	/**
	 * description
	 *
	 * @var string
	 */
	protected $description = '';

	/**
	 * gtin
	 *
	 * @var string
	 */
	protected $gtin = '';

	/**
	 * gtin
	 *
	 * @var string
	 */
	protected $mpn = '';


	/**
	 * price
	 *
	 * @var float
	 */
	protected $price;

	/**
	 * priceEuro
	 *
	 * @var float
	 */
	protected $priceEuro;

	/**
	 * active
	 *
	 * @var boolean
	 */
	protected $onlySwiss = FALSE;

	/**
	 * sorting
	 *
	 * @var integer
	 */
	protected $sorting = 0;

	/**
	 * prices
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productprice>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $prices = NULL;

	/**
	 * image
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
	 * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade remove
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
	 */
	protected $image = NULL;

    /**
     * deliveryPeriod
     * @var \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $deliveryPeriod = null;


	/**
	 * __construct
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties
	 * Do not modify this method!
	 * It will be rewritten on each save in the extension builder
	 * You may modify the constructor of this class instead
	 *
	 * @return void
	 */
	protected function initStorageObjects() {
		$this->prices = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->image = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
	}

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the gtin
	 *
	 * @return string $gtin
	 */
	public function getGtin() {
	  return $this->gtin;
	}

	/**
	 * Sets the gtin
	 *
	 * @param string $gtin
	 * @return void
	 */
	public function setGtin($gtin) {
	  $this->name = $gtin;
	}

	/**
	 * Returns the mpn
	 *
	 * @return string $mpn
	 */
	public function getMpn() {
	  return $this->mpn;
	}

	/**
	 * Sets the mpn
	 *
	 * @param string $mpn
	 * @return void
	 */
	public function setMpn($mpn) {
	  $this->name = $mpn;
	}

	/**
	 * Returns the price
	 *
	 * @return float $price
	 */
	public function getPrice() {
		return $this->price;
	}

	/**
	 * Sets the price
	 *
	 * @param float $price
	 * @return void
	 */
	public function setPrice($price) {
		$this->price = $price;
	}

	/**
	 * Returns the priceEuro
	 *
	 * @return float $priceEuro
	 */
	public function getPriceEuro() {
		return $this->priceEuro;
	}

	/**
	 * Sets the priceEuro
	 *
	 * @param float $priceEuro
	 * @return void
	 */
	public function setPriceEuro($priceEuro) {
		$this->priceEuro = $priceEuro;
	}

	/**
	 * Returns the onlySwiss
	 *
	 * @return boolean $onlySwiss
	 */
	public function getOnlySwiss() {
		return $this->onlySwiss;
	}

	/**
	 * Sets the onlySwiss
	 *
	 * @param boolean $onlySwiss
	 * @return void
	 */
	public function setOnlySwiss($onlySwiss) {
		$this->onlySwiss = $onlySwiss;
	}

	/**
	 * Returns the boolean state of onlySwiss
	 *
	 * @return boolean
	 */
	public function isOnlySwiss() {
		return $this->onlySwiss;
	}

	/**
	 * Returns the sorting
	 *
	 * @return integer $sorting
	 */
	public function getSorting() {
		return $this->sorting;
	}

	/**
	 * Sets the sorting
	 *
	 * @param integer $sorting
	 * @return void
	 */
	public function setSorting($sorting) {
		$this->sorting = $sorting;
	}

	/**
	 * Adds a ProductPrice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\ProductPrice $productPrice
	 * @return void
	 */
	public function addPrices(\InternetGalerie\Igshop2\Domain\Model\Productprice $prices) {
		$this->prices->attach($prices);
	}

	/**
	 * Removes a ProductPrice
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\ProductPrice $pricesToRemove The ProductPrice to be removed
	 * @return void
	 */
	public function removePrices(\InternetGalerie\Igshop2\Domain\Model\Productprice $pricesToRemove) {
		$this->prices->detach($pricesToRemove);
	}

	/**
	 * Returns the ProductPrice
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\ProductPrice> $prices
	 */
	public function getPrices() {
		return $this->prices;
	}

	/**
	 * Sets the Prices
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\InternetGalerie\Igshop2\Domain\Model\Productprice> $prices
	 * @return void
	 */
	public function setPrices(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $prices) {
		$this->prices = $prices;
	}

	public function getOptionPrice(\InternetGalerie\Igshop2\Domain\Model\Currency $currency, $amount = 0){
		if($this->onlySwiss && $currency->getShort() != "CHF"){
			return null;
		}

		if($amount > 0 && count($this->prices) > 0){
			$retPrice = null;
			foreach($this->prices AS $price){
			  //echo($price->getAmount() .'='. $price->getPrice() .'<br />');
				if(!is_object($retPrice) && $price->getAmount() <= $amount){
					$retPrice = $price;
				}

				if(is_object($retPrice) && $price->getAmount() <= $amount && $retPrice->getAmount() < $amount){
					$retPrice = $price;
				}
			}
			if(is_object($retPrice)){
				if($currency->getShort() == "EUR" && $retPrice->getPriceEuro() != null)
					return $retPrice->getPriceEuro();
				return $retPrice->getPrice() * $currency->getFaktor();
			}
		}

		if($currency->getShort() == "EUR" && $this->priceEuro != null)
			return $this->priceEuro;
		return $this->price * $currency->getFaktor();
	}



	/**
	 * Adds a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 * @return void
	 */
	public function addImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image) {
		$this->image->attach($image);
	}

	/**
	 * Removes a FileReference
	 *
	 * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove The FileReference to be removed
	 * @return void
	 */
	public function removeImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove) {
		$this->image->detach($imageToRemove);
	}

	/**
	 * Returns the image
	 *
	 * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 */
	public function getImage() {
		return $this->image;
	}

	/**
	 * Returns the mainimage
	 *
	 * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
	 */
	public function getMainImageLocalized() {
	  $imgs = $this->getImage();
	  foreach( $imgs as $i) {
	    return $i;
	  }
	  return false;
	}


	/**
	 * Sets the image
	 *
	 * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
	 * @return void
	 */
	public function setImage(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $image) {
		$this->image = $image;
	}

    /**
     * @return \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod
     */
    public function getDeliveryPeriod(){
        return $this->deliveryPeriod;
    }

    /**
     * @param \InternetGalerie\Igshop2\Domain\Model\DeliveryPeriod $deliveryPeriod
     * @return void
     */
    public function setDeliveryPeriod($deliveryPeriod){
        $this->deliveryPeriod = $deliveryPeriod;
    }


	/**
	 * Ist Produkt verfügbar in dieser Währung
	 *
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 *
	 * @return boolean
	 */
	public function isAvailable(\InternetGalerie\Igshop2\Domain\Model\Currency $currency) {
	  if($currency->getShort() == 'EUR' && $this->getPriceEuro() !== null && $this->getPriceEuro()<=0) {
	    return false;
	  } else {
	    return true;
	  }
	}


	/**
	 * Returns the correct price, if there is set a special price order the customer is a member
	 * @param \InternetGalerie\Igshop2\Domain\Model\Currency $currency
	 * @param int $optionWithPriceUid
	 * @param int $amount
	 * @param boolean $checkForPromotion
	 * @return float
	 *
	 */
	public function getFinalPrice($currency) {
	  if(!$this->isAvailable($currency) && $notAvailableText !==false)
	    return $notAvailableText;

	  if($currency->getShort() == "EUR" && $this->getPriceEuro() !== null ){
	      return $this->getPriceEuro();
	  }else{
	    return $this->getPrice() * $currency->getFaktor();
	  }
	}

	public function getCurrencyClasses() {
	  $content='';
	  $currencyRepository = GeneralUtility::makeInstance(CurrencyRepository::class);
	  $currencies = $currencyRepository->findAllForPrices();
          foreach( $currencies as $currency ) {
	    if($this->isAvailable($currency)) {
	      if($content)
		$content.=' ';
	      $content.='currency-'.$currency->getShort();
	    }
	  }
	  return $content;
	}


    /**
     * Get the value of description
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Set the value of description
     *
     * @param string $description
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->description = $description;

        return $this;
    }

}
