<?php
namespace InternetGalerie\Igshop2\ViewHelpers;

/**
 * This class is a demo view helper for the Fluid templating engine.
 *
 * @package TYPO3
 * @subpackage Fluid
 * @version
 */
class IsOnlySwissViewHelper extends \TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper {
    public function initializeArguments(): void
	{
        parent::initializeArguments();
        
        $this->registerArgument('orderProduct', \InternetGalerie\Igshop2\Domain\Model\OrderProduct::class, 'Order product', true);
        $this->registerArgument('currency', \InternetGalerie\Igshop2\Domain\Model\Currency::class, 'Currency', true);
    }

    /**
     * Rounds the price to CHF norm
	 * 
	 * @return boolean
     */
	public function render(): string
	{
	    $orderProduct = $this->arguments['orderProduct'];
        $currency = $this->arguments['currency'];
        
		if($currency->getShort() != "EUR" ){
			return false;
		}
		
		if($orderProduct->getProduct()->isOnlySwiss())
			return true;
		
		$prodOptions = unserialize($orderProduct->getProdOptions());
		$option = $prodOptions['optionWithPrice'];
		foreach($orderProduct->getProduct()->getOptionsWithPrice() AS $size){
			if($size->getUid() == $option){
				if($size->isOnlySwiss()){
					return true;
				}
			}
		}
		return false;
	}
}

?>