<?php
defined('TYPO3') or die();

$versionInformation = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Information\Typo3Version::class);
if($versionInformation->getMajorVersion() < 12) {
    \Internetgalerie\IgBackendHelpers\Utility\ExtensionUtility::registerMainModule(
        'Igshop2',
        'after:file',
        [
            'access' => 'group,user',
            'icon' => 'EXT:igshop2/Resources/Public/Icons/module-shop.svg',
            'labels' => 'LLL:EXT:igshop2/Resources/Private/Language/locallangNavShop.xlf'
        ]
    );

    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerModule(
        'Igshop2',
        'Igshop2',
        'backendProduct',
        'top',
        [
            \InternetGalerie\Igshop2\Controller\BackendProductController::class => 'index, sortProductsInCategory',
            \InternetGalerie\Igshop2\Controller\BackendCategoryController::class => 'index',
        ],
        [
            'access' => 'user,group',
            'workspaces'=> 'online',
            'icon' => 'EXT:igshop2/Resources/Public/Icons/module-shop-products.svg',
            'labels' => 'LLL:EXT:igshop2/Resources/Private/Language/locallangNavProduct.xlf',
            'name' => 'IgShop2Frame_backendProduct',
            'navigationComponentId' => 'TYPO3/CMS/Igshop2/Tree/CategoryTreeElement',

        ]
    );
    \TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerModule(
        'Igshop2',
        'Igshop2',
        'backendCategory',
        'top',
        [
            \InternetGalerie\Igshop2\Controller\BackendCategoryController::class => 'index',
            \InternetGalerie\Igshop2\Controller\BackendProductController::class => 'index, sortProductsInCategory',
        ],
        [
            'access' => 'user,group',
            'workspaces'=> 'online',
            'icon' => 'EXT:igshop2/Resources/Public/Icons/module-shop-categories.svg',
            'labels' => 'LLL:EXT:igshop2/Resources/Private/Language/locallangNavCategory.xlf',
            'name' => 'IgShop2Frame_backendCategory',
            'navigationComponentId' => 'TYPO3/CMS/Igshop2/Tree/CategoryTreeElement',
        ]
    );
}
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTypoScriptSetup(
    '
	module.tx_dashboard {
		view {
			templateRootPaths.1588324052 = EXT:igshop2/Resources/Private/Backend/Templates/
			partialRootPaths.1588324052 = EXT:igshop2/Resources/Private/Backend/Partials/
			layoutRootPaths.1588324052 = EXT:igshop2/Resources/Private/Backend/Layouts/
		}
	}'
);
